/* Funkbots 1.15: Copyright 1998  Jonathan Sharkey. Please read reame.txt
for important info */

#include "fb.h"

ISHORT time1, donecount, robwon;

void do_battle(void)
{
  ISHORT i, time2;
  char string[32];

  /* set up screen */
  rectfill(bat_scr, 0, 0, 100, var.res_y - 1, 87);
  vline(bat_scr, 101, 0, var.res_y - 1, 0);

  var.x1 = (var.res_x - 101) / 2 - var.area_x / 2 + 102;
  var.x2 = var.x1 + var.area_x - 1;
  var.y1 = var.res_y / 2 - var.area_y / 2;
  var.y2 = var.y1 + var.area_y - 1;

  if (var.x1 < 102)
    var.x1 = 102;
  if (var.x2 > var.res_x - 1)
    var.x2 = var.res_x - 1;
  if (var.y1 < 0)
    var.y1 = 0;
  if (var.y2 > var.res_y - 1)
    var.y2 = var.res_y - 1;

  rectfill(bat_scr, 102, 0, var.res_x - 1, var.res_y - 1, 147);
  rect(bat_scr, var.x1 - 1, var.y1 - 1, var.x2 + 1, var.y2 + 1, 1);
  rectfill(bat_scr, var.x1, var.y1, var.x2, var.y2, 118);

  set_clip(bat_scr, var.x1, var.y1, var.x2, var.y2);
  draw_screen();
  set_clip(screen, 0, 0, var.res_x - 1, var.res_y - 1);
  blit(bat_scr, screen, 0, 0, 0, 0, var.res_x, var.res_y);
  draw_stats();

  fade_in(gamedata[PAL].dat, 8);

  install_int_ex(counter, BPS_TO_TIMER(var.game_speed));
  time2 = 0;
  donecount = -1;
  robwon = -1;
  while(!key[KEY_ESC]) {
    while(time2 == time1);
    time2 = time1;
    do_robots();
    do_items();
    do_shots();
    do_expls();
    draw_screen();
    if (donecount > 0) {
      donecount--;
      if (donecount == 0)
        break;
    }
    if (key[KEY_F1]) {
      i = 0;
      while(1) {
        sprintf(string, "%i.pcx", i);
        if (!__file_exists(string))
          break;
        i++;
      }
      set_clip(bat_scr, 0, 0, var.res_x - 1, var.res_y - 1);
      blit(screen, bat_scr, 0, 0, 0, 0, var.res_x, var.res_y);
      save_pcx(string, bat_scr, gamedata[PAL].dat);
      while(key[KEY_F1]);
    }
    if (key[KEY_PAUSE]) {
      while(key[KEY_PAUSE]);
      while(!key[KEY_PAUSE]);
      while(key[KEY_PAUSE]);
    }
  }
  stop_sample(gamedata[SEEK].dat);
  if (robwon >= 0) {
    set_clip(screen, 0, 0, var.res_x - 1, var.res_y - 1);
    text_mode(159);
    sprintf(string, "FunkBot %i, %s, won! Funky!", robwon, robot[robwon].name);
    textout_centre(screen, font, string, var.res_x / 2, var.res_y / 2 - 20, 0);
    play_sample(gamedata[FUNKY].dat, 255, 128, 750, FALSE);
    while(!key[KEY_ENTER] && !key[KEY_ESC]);
  }
  fade_out(8);
}

void counter(void)
{
  time1++;
  if (time1 > 200)
    time1 = 0;
}

void draw_stats(void)
{
  char string[20];
  static ISHORT top = 0, wait = 0;
  ISHORT i, pos;

  set_clip(screen, 0, 0, 100, var.res_y - 1);
  if (key[KEY_UP] && top > 0 && !wait) {
    top--;
    wait = 1;
    rectfill(screen, 0, 0, 100, var.res_y - 1, 87);
  }
  if (key[KEY_DOWN] && top < var.total_robots - var.res_y / 96 && !wait) {
    top++;
    wait = 1;
    rectfill(screen, 0, 0, 100, var.res_y - 1, 87);
  }
  if (!key[KEY_DOWN] && !key[KEY_UP])
    wait = 0;

  for (i = top; i < var.total_robots && i < top + var.res_y / 96; i++) {
    pos = i - top;
    text_mode(87);
    sprintf(string, "%i: %s", i, robot[i].name);
    textout(screen, font, string, 4, 5 + pos * 95, 0);
    sprintf(string, "Energy: %i ", robot[i].energy);
    textout(screen, font, string, 4, 15 + pos * 95, 0);
    sprintf(string, "X:      %i ", robot[i].x);
    textout(screen, font, string, 4, 23 + pos * 95, 0);
    sprintf(string, "Y:      %i ", robot[i].y);
    textout(screen, font, string, 4, 31 + pos * 95, 0);
    sprintf(string, "Normal: %i ", robot[i].ammo[NORMAL]);
    textout(screen, font, string, 4, 39 + pos * 95, 0);
    sprintf(string, "Power:  %i ", robot[i].ammo[POWER]);
    textout(screen, font, string, 4, 47 + pos * 95, 0);
    sprintf(string, "Seek:   %i ", robot[i].ammo[SEEKS]);
    textout(screen, font, string, 4, 55 + pos * 95, 0);
    sprintf(string, "P Seek: %i ", robot[i].ammo[PSEEK]);
    textout(screen, font, string, 4, 63 + pos * 95, 0);
    sprintf(string, "Mine:   %i ", robot[i].ammo[MINES]);
    textout(screen, font, string, 4, 71 + pos * 95, 0);
    sprintf(string, "P Mine: %i ", robot[i].ammo[PMINE]);
    textout(screen, font, string, 4, 79 + pos * 95, 0);
    sprintf(string, "D: %f", robot[i].debug);
    textout(screen, font, string, 4, 87 + pos * 95, 0);
  }
}

void draw_screen(void)
{
  ISHORT i, j, old_x, old_y, xm, ym;
  int x, y;
  char string[15];
  ISHORT typei[9] = {ITEMN, ITEMP, ITEMS, ITEMSP, ITEMM, ITEMMP, ITEM1, ITEM2,
                    ITEM5};
  ISHORT types[6] = {SHOTN, SHOTP, SHOTS, SHOTSP, SHOTM, SHOTMP};
  static pos_count = 0;

  old_x = var.pos_x;
  old_y = var.pos_y;
  get_mouse_mickeys(&x, &y);
  var.pos_x += x;
  var.pos_y += y;
  if (var.pos_x < 0)
    var.pos_x = 0;
  if (var.pos_x > var.area_x - (var.x2 - var.x1 + 1))
    var.pos_x = var.area_x - (var.x2 - var.x1 + 1);
  if (var.pos_y < 0)
    var.pos_y = 0;
  if (var.pos_y > var.area_y - (var.y2 - var.y1 + 1))
    var.pos_y = var.area_y - (var.y2 - var.y1 + 1);

  xm = var.x1 - var.pos_x;
  ym = var.y1 - var.pos_y;

  if (var.pos_x != old_x || var.pos_y != old_y) {
    for (i = 0; i < var.num_covers; i++) {
      cover_it[i].x -= (old_x - var.pos_x);
      cover_it[i].y -= (old_y - var.pos_y);
    }
    pos_count = 30;
    for (i = 0; i < var.total_robots; i++) {
      if (robot[i].alive) {
        cover_it[var.num_covers].x = robot[i].x - 16 - (old_x - var.pos_x);
        cover_it[var.num_covers].y = robot[i].y - 22 - (old_y - var.pos_y);
        cover_it[var.num_covers].x_size = 32;
        cover_it[var.num_covers].y_size = 55;
        var.num_covers++;
      }
    }
    for (i = 0; i < var.total_items; i++) {
      cover_it[var.num_covers].x = item[i].x - 8 - (old_x - var.pos_x);
      cover_it[var.num_covers].y = item[i].y - 8 - (old_y - var.pos_y);
      cover_it[var.num_covers].x_size = 16;
      cover_it[var.num_covers].y_size = 16;
      var.num_covers++;
    }
    for (i = 0; i < var.total_shots; i++) {
      cover_it[var.num_covers].x = shot[i].x / 100 - 9 - (old_x - var.pos_x);
      cover_it[var.num_covers].y = shot[i].y / 100 - 9 - (old_y - var.pos_y);
      cover_it[var.num_covers].x_size = 18;
      cover_it[var.num_covers].y_size = 18;
      var.num_covers++;
    }
    for (i = 0; i < var.total_expls; i++) {
      cover_it[var.num_covers].x = expl[i].x + robot[expl[i].robot].x -
      (old_x - var.pos_x) - 3;
      cover_it[var.num_covers].y = expl[i].y + robot[expl[i].robot].y -
      (old_y - var.pos_y) - 3;
      cover_it[var.num_covers].x_size = 86;
      cover_it[var.num_covers].y_size = 86;
      var.num_covers++;
    }
  }

  text_mode(-1);
  set_clip(screen, var.x1, var.y1, var.x2, var.y2);
  rectfill(bat_scr, var.x1, var.y1, var.x2, var.y2, 118);

  for (i = 0; i < var.total_robots; i++)
    if (robot[i].alive) {
      masked_blit(robot[i].image, bat_scr, 0, 0, robot[i].x + xm - 15,
                  robot[i].y - 21 + ym, 30, 42);
      textout_centre(bat_scr, font, itoa(i, string, 10), robot[i].x + xm + 1,
                     robot[i].y + 14 + ym, 255);
      textout_centre(bat_scr, font, itoa(robot[i].energy, string, 10),
                     robot[i].x + xm + 1, robot[i].y + 23 + ym, 0);
    }
  for (i = 0; i < var.total_items; i++)
    masked_blit(gamedata[typei[item[i].type]].dat, bat_scr, 0, 0,
                item[i].x + xm - 7, item[i].y - 7 + ym, 15, 15);
  for (i = 0; i < var.total_shots; i++)
    masked_blit(gamedata[types[shot[i].type]].dat, bat_scr, 0, 0,
                shot[i].x / 100 + xm - 5, shot[i].y / 100 + ym - 5, 10, 10);
  for (i = 0; i < var.total_expls; i++)
    masked_blit(gamedata[E01_PCX + expl[i].frame].dat, bat_scr, 0, 0,
                robot[expl[i].robot].x + expl[i].x + xm,
                robot[expl[i].robot].y + expl[i].y + ym, 80, 80);

  for (i = 0; i < var.total_robots; i++)
    if (robot[i].alive)
      blit(bat_scr, screen, robot[i].x + xm - 16, robot[i].y + ym - 23,
           robot[i].x + xm - 16, robot[i].y + ym - 23, 32, 54);
  for (i = 0; i < var.total_items; i++)
    blit(bat_scr, screen, item[i].x + xm - 7, item[i].y + ym - 7,
         item[i].x + xm - 7, item[i].y + ym - 7, 15, 15);
  for (i = 0; i < var.total_shots; i++)
    blit(bat_scr, screen, shot[i].x / 100 + xm - 8, shot[i].y / 100 - 9
         + ym, shot[i].x / 100 + xm - 8, shot[i].y / 100 - 9 + ym
         , 18, 18);
  for (i = 0; i < var.total_expls; i++)
    blit(bat_scr, screen, robot[expl[i].robot].x + expl[i].x + xm - 2,
         robot[expl[i].robot].y - 2 + expl[i].y + ym,
         robot[expl[i].robot].x + expl[i].x + xm - 2,
         robot[expl[i].robot].y - 2 + expl[i].y + ym, 84, 84);
  for (i = 0; i < var.num_covers; i++)
    blit(bat_scr, screen, cover_it[i].x + xm, cover_it[i].y + ym,
    cover_it[i].x + xm, cover_it[i].y + ym, cover_it[i].x_size,
    cover_it[i].y_size);
  var.num_covers = 0;

 if (pos_count) {
    text_mode(1);
    sprintf(string, "(%i, %i)", var.pos_x, var.pos_y);
    textout(bat_scr, font, string, var.x1, var.y1, 255);
    blit(bat_scr, screen, var.x1, var.y1, var.x1, var.y1, 100, 8);
    pos_count--;
  }

  /*
  if (var.pos_x != old_x || var.pos_y != old_y) {
    pos_count = 30;
    blit(bat_scr, screen, 102, 0, 102, 0, var.res_x - 102, var.res_y);
  }
  */

  if (pos_count == 0) {
    blit(bat_scr, screen, var.x1, var.y1, var.x1, var.y1, 100, 8);
    pos_count--;
  }

  draw_stats();
}

void do_items(void)
{

  ISHORT j, i, k, i1, i2, ich;

  if (!var.item_count && var.total_items < 256) {
    item[var.total_items].x = randnum(var.area_x);
    item[var.total_items].y = randnum(var.area_y);
    item[var.total_items].type = var.chance[randnum(var.num_chance)];
    var.total_items++;
    play_sample(gamedata[ITEM].dat, 255, 128, 1000, FALSE);
  }
  var.item_count++;
  if (var.item_count > var.item_delay)
    var.item_count = 0;

  if (randnum(2)) {
    i1 = 0;
    i2 = var.total_robots;
    ich = 1;
  }
  else {
    i1 = var.total_robots;
    i2 = -1;
    ich = -1;
  }
  for (i = i1; i != i2; i += ich)
    if (robot[i].alive)
      for (j = 0; j < var.total_items; j++)
        if (item[j].x > robot[i].x - 24 && item[j].x < robot[i].x + 23 &&
        item[j].y > robot[i].y - 29 && item[j].y < robot[i].y + 29) {
          cover_it[var.num_covers].x = item[j].x - 7;
          cover_it[var.num_covers].x_size = 15;
          cover_it[var.num_covers].y = item[j].y - 7;
          cover_it[var.num_covers].y_size = 15;
          var.num_covers++;
          if (item[j].type < ENERGY1)
            robot[i].ammo[item[j].type] += 3;
          if (item[j].type == ENERGY1)
            robot[i].energy++;
          if (item[j].type == ENERGY2)
            robot[i].energy += 2;
          if (item[j].type == ENERGY5)
            robot[i].energy += 5;

          for (k = j; k < var.total_items - 1; k++) {
             item[k].x = item[k + 1].x;
             item[k].y = item[k + 1].y;
             item[k].type = item[k + 1].type;
          }
          var.total_items--;
        }
}

void do_shots(void)
{
  ISHORT i, i1, i2, ich, j, k, x, y, tdist, dist, clrob, tspeed_x, tspeed_y;

  for (i = 0; i < var.total_shots; i++) {
    shot[i].x += shot[i].speed_x;
    shot[i].y += shot[i].speed_y;

    if ((shot[i].type == MINES || shot[i].type == PMINE) && shot[i].count) {
      shot[i].count--;
      if (!shot[i].count) {
        shot[i].speed_x = 0;
        shot[i].speed_y = 0;
      }
    }
    if (shot[i].type == SEEKS || shot[i].type == PSEEK) {
      dist = 1000;
      for (j = 0; j < var.total_robots; j++) {
        x = robot[j].x - shot[i].x / 100;
        y = robot[j].y - shot[i].y / 100;
        if (x < 0)
          x = -x;
        if (y < 0)
          y = -y;

        if (!x) x = 1;
        if (!y) y = 1;

        if (y > x)
          tdist = y;
        else
          tdist = x;

        if (tdist < dist && j != shot[i].robot && robot[j].alive) {
          dist = tdist;
          clrob = j;
          if (x > y) {
            tspeed_x = 300;
            tspeed_y = (y * 300 / x);
          }
          else {
            tspeed_y = 300;
            tspeed_x = (x * 300 / y);
          }
          if (robot[j].x < shot[i].x / 100)
            tspeed_x = -tspeed_x;
          if (robot[j].y < shot[i].y / 100)
            tspeed_y =  -tspeed_y;
        }
      }

      if (var.robots_alive < 2) {
        tspeed_x = 0;
        tspeed_y = 0;
      }

      if (tspeed_y > shot[i].speed_y)
        shot[i].speed_y += 4;
      if (tspeed_y < shot[i].speed_y)
        shot[i].speed_y -= 4;
      if (tspeed_x > shot[i].speed_x)
        shot[i].speed_x += 4;
      if (tspeed_x < shot[i].speed_x)
        shot[i].speed_x -= 4;
    }
  }

  for (i = 0; i < var.total_shots; i++) {
    if (shot[i].x < -6000 || shot[i].x > var.area_x * 100 + 6000 ||
    shot[i].y < -6000 || shot[i].y > var.area_y * 100 + 6000) {
      y = 0;
      for (x = 0; x < var.total_shots; x++)
        if ((shot[x].type == SEEKS || shot[x].type == PSEEK) && x != j)
          y++;
      if (!y && (shot[i].type == SEEKS || shot[i].type == PSEEK))
        stop_sample(gamedata[SEEK].dat);

      for (k = i; k < var.total_shots - 1; k++) {
        shot[k].x = shot[k + 1].x;
        shot[k].y = shot[k + 1].y;
        shot[k].speed_x = shot[k + 1].speed_x;
        shot[k].speed_y = shot[k + 1].speed_y;
        shot[k].type = shot[k + 1].type;
        shot[k].robot = shot[k + 1].robot;
        shot[k].count = shot[k + 1].count;
      }
      var.total_shots--;
    }
  }

  if (randnum(2)) {
    i1 = 0;
    i2 = var.total_robots;
    ich = 1;
  }
  else {
    i1 = var.total_robots;
    i2 = -1;
    ich = -1;
  }

  for (i = i1; i != i2; i += ich)
    if (robot[i].alive)
      for (j = 0; j < var.total_shots; j++)
        if (shot[j].x / 100 > robot[i].x - 22 &&
        shot[j].x / 100 < robot[i].x + 21 &&
        shot[j].y / 100 > robot[i].y - 27 &&
        shot[j].y / 100 < robot[i].y + 27 && i != shot[j].robot) {

          robot[shot[j].robot].total_hits++;
          robot[shot[j].robot].hits[i]++;
          if (shot[j].type == NORMAL || shot[j].type == SEEKS ||
          shot[j].type == MINES)
            robot[i].energy--;
          else
            robot[i].energy -= 2;

          if (robot[i].energy < 1) {
            robot[shot[j].robot].kills++;
            robot[i].energy = 0;
            robot[i].alive = FALSE;
            var.robots_alive--;
            expl[var.total_expls].x = -40;
            expl[var.total_expls].y = -40;
            expl[var.total_expls].frame = 0;
            expl[var.total_expls].robot = i;
            var.total_expls++;
            cover_it[var.num_covers].x = robot[i].x - 19;
            cover_it[var.num_covers].x_size = 40;
            cover_it[var.num_covers].y = robot[i].y - 21;
            cover_it[var.num_covers].y_size = 42;
            var.num_covers++;
            play_sample(gamedata[DIE].dat, 255, 128, 1000, FALSE);

            if (var.robots_alive < 2) {
              for (x = 0; x < var.total_robots; x++)
                if (robot[x].alive)
                  robwon = x;
              donecount = 90;
            }
          }
          expl[var.total_expls].x = shot[j].x / 100 - robot[i].x - 40;
          expl[var.total_expls].y = shot[j].y / 100 - robot[i].y - 40;
          expl[var.total_expls].frame = 0;
          expl[var.total_expls].robot = i;
          for (k = j; k < var.total_shots - 1; k++) {
             shot[k].x = shot[k + 1].x;
             shot[k].y = shot[k + 1].y;
             shot[k].speed_x = shot[k + 1].speed_x;
             shot[k].speed_y = shot[k + 1].speed_y;
             shot[k].type = shot[k + 1].type;
             shot[k].robot = shot[k + 1].robot;
             shot[k].count = shot[k + 1].count;
          }
          var.total_shots--;
          var.total_expls++;
          play_sample(gamedata[BOOM].dat, 255, 128, 1000, FALSE);
        }
  y = 0;
  for (x = 0; x < var.total_shots; x++)
    if (shot[x].type == SEEKS || shot[x].type == PSEEK)
      y++;
    if (!y)
      stop_sample(gamedata[SEEK].dat);

}

void do_expls(void)
{
  ISHORT i, k;

  for (i = 0; i < var.total_expls; i++) {
    expl[i].frame++;
    if (expl[i].frame > 30) {
      cover_it[var.num_covers].x = robot[expl[i].robot].x + expl[i].x;
      cover_it[var.num_covers].x_size = 80;
      cover_it[var.num_covers].y = robot[expl[i].robot].y + expl[i].y;
      cover_it[var.num_covers].y_size = 80;
      var.num_covers++;
      for (k = i; k < var.total_expls - 1; k++) {
        expl[k].x = expl[k + 1].x;
        expl[k].y = expl[k + 1].y;
        expl[k].robot = expl[k + 1].robot;
        expl[k].frame = expl[k + 1].frame;
      }
      var.total_expls--;
    }
  }
}
