/* Funkbots 1.15: Copyright 1998  Jonathan Sharkey. Please read reame.txt
for important info */

#include "fb.h"

int code_pos, rob;
ISHORT old_x, old_y;

void do_robots(void)
{
  ISHORT i, code_byte, index, num_loops;
  int loop_start[50];

  for (rob = 0; rob < var.total_robots; rob++) {
    num_loops = 0;
    if (robot[rob].alive) {
      code_pos = -1;
      old_x = robot[rob].x;
      old_y = robot[rob].y;
      if (robot[rob].shot_count)
        robot[rob].shot_count--;

      while(code_pos < robot[rob].code_size && !key[KEY_ESC]) {
        code_byte = read_byte();
        switch(code_byte) {
          case(1):
            read_byte();
            robot[rob].x = (ISHORT)read_value();
          break;
          case(2):
            read_byte();
            robot[rob].y = (ISHORT)read_value();
          break;
          case(3):
            index = (ISHORT)read_value();
            if (index < 0)
              index = 0;
            if (index > 999)
              index = 999;
            read_byte();
            robot[rob].data[index] = read_value();
          break;
          case(61):
            read_byte();
            robot[rob].debug = read_value();
          break;
          case(41 /* IF */):
            do_if();
          break;
          case(66 /* ELSE */):
            skip_else_code();
          break;
          case(43 /* DO */):
            num_loops++;
            loop_start[num_loops] = code_pos;
          break;
          case(44 /* BREAK */):
            num_loops--;
            while(read_byte() != 45); /* "loop" */
          break;
          case(45 /* LOOP */):
            if (num_loops)
              code_pos = loop_start[num_loops];
          break;
          case(46):
            start_shot();
          break;
        };
      }
      /* reinforce 1 pixel movement */
      if (robot[rob].x < old_x - 1)
        robot[rob].x = old_x - 1;
      if (robot[rob].x > old_x + 1)
        robot[rob].x = old_x + 1;
      if (robot[rob].y < old_y - 1)
        robot[rob].y = old_y - 1;
      if (robot[rob].y > old_y + 1)
        robot[rob].y = old_y + 1;
      /* don't let robot leave field */
      if (robot[rob].x < 0)
        robot[rob].x = 0;
      if (robot[rob].x > var.area_x - 1)
        robot[rob].x = var.area_x - 1;
      if (robot[rob].y < 0)
        robot[rob].y = 0;
      if (robot[rob].y > var.area_y - 1)
        robot[rob].y = var.area_y - 1;
    }
  }
}

ISHORT read_byte(void)
{
  code_pos++;
  return(robot[rob].code[code_pos]);
}

float read_value(void)
{
  float value[100], val, *floater;
  ISHORT oper[49], num_vals, i, j, val1;

  num_vals = 0;
  while(1) {
    val1 = read_byte();
    switch(val1) {
      case(0):
        floater = (float *)&robot[rob].code[code_pos + 1];
        value[num_vals] = *floater;
        code_pos += 2;
      break;
      case(1): value[num_vals] = calc_x(read_value()); break;
      case(2): value[num_vals] = calc_y(read_value()); break;
      case(3): value[num_vals] = robot[rob].data[(int)read_value()]; break;
      case(4): value[num_vals] = robot[(int)read_value()].energy; break;
      case(5): value[num_vals] = robot[(int)read_value()].ammo[(int)read_value()]; break;
      case(6): value[num_vals] = var.robots_alive; break;
      case(7): value[num_vals] = var.total_robots; break;
      case(8): value[num_vals] = var.total_shots; break;
      case(9): value[num_vals] = robot[(int)read_value()].alive; break;
      case(10): value[num_vals] = var.item_delay; break;
      case(11): value[num_vals] = var.total_items; break;
      case(12): value[num_vals] = var.item_chance[(int)read_value()]; break;
      case(13): value[num_vals] = item[(int)read_value()].x; break;
      case(14): value[num_vals] = item[(int)read_value()].y; break;
      case(15): value[num_vals] = item[(int)read_value()].type; break;
      case(16): value[num_vals] = var.total_shots; break;
      case(17): value[num_vals] = (float)shot[(int)read_value()].x / 100; break;
      case(18): value[num_vals] = (float)shot[(int)read_value()].y / 100; break;
      case(19): value[num_vals] = (float)shot[(int)read_value()].speed_x / 100; break;
      case(20): value[num_vals] = (float)shot[(int)read_value()].speed_y / 100; break;
      case(21): value[num_vals] = shot[(int)read_value()].type; break;
      case(22): value[num_vals] = NORMAL; break;
      case(23): value[num_vals] = POWER; break;
      case(24): value[num_vals] = SEEKS; break;
      case(25): value[num_vals] = PSEEK; break;
      case(26): value[num_vals] = MINES; break;
      case(27): value[num_vals] = PMINE; break;
      case(28): value[num_vals] = ENERGY1; break;
      case(29): value[num_vals] = ENERGY2; break;
      case(30): value[num_vals] = ENERGY5; break;
      case(47): value[num_vals] = rob; break;
      case(49): value[num_vals] = read_value(); break;
      case(51): value[num_vals] = randnum((int)read_value()); break;
      case(55): value[num_vals] = robot[(int)read_value()].total_hits; break;
      case(56): value[num_vals] = robot[(int)read_value()].hits[(int)read_value()]; break;
      case(57): value[num_vals] = robot[(int)read_value()].kills; break;
      case(58): value[num_vals] = shot[(int)read_value()].robot; break;
      case(61): value[num_vals] = robot[rob].debug; break;
      case(59): value[num_vals] = var.area_x; break;
      case(60): value[num_vals] = var.area_y; break;
      case(64): value[num_vals] = (float)sqrt((double)read_value()); break;
      default: value[num_vals] = (float)val1; break;
    }

    oper[num_vals] = read_byte();
    if (oper[num_vals] < 31 /* '+' */ || (oper[num_vals] > 40
    && oper[num_vals] < 52) || (oper[num_vals] > 54 && oper[num_vals] != 65))
      break;
    num_vals++;
  }
  if (oper[num_vals] != 48 /* ']' */ && oper[num_vals] != 50 /* ')' */)
    code_pos--;

  num_vals++;

  if (num_vals == 1)
    return(value[0]);

  mark0:
  for (i = 0; i < num_vals - 1; i++) {
    if (oper[i] == 65) {
      val = (float)pow((double)value[i], (double)value[i + 1]);
      value[i] = val;
      for (j = i + 1; j < num_vals - 1; j++) {
        value[j] = value[j + 1];
        oper[j - 1] = oper[j];
      }
      num_vals--;
      goto mark0;
    }
  }

  mark1:
  for (i = 0; i < num_vals - 1; i++) {
    if (oper[i] == 33 || oper[i] == 34 || oper[i] == 35) {
      if (oper[i] == 33)
        val = value[i] / value[i + 1];
      if (oper[i] == 34)
        val = value[i] * value[i + 1];
      if (oper[i] == 35)
        val = (int)value[i] % (int)value[i + 1];
      value[i] = val;
      for (j = i + 1; j < num_vals - 1; j++) {
        value[j] = value[j + 1];
        oper[j - 1] = oper[j];
      }
      num_vals--;
      goto mark1;
    }
  }
  mark2:
  for (i = 0; i < num_vals - 1; i++) {
    if (oper[i] == 31 || oper[i] == 32) {
      if (oper[i] == 31)
        val = value[i] + value[i + 1];
      else
        val = value[i] - value[i + 1];
      value[i] = val;
      for (j = i + 1; j < num_vals - 1; j++) {
        value[j] = value[j + 1];
        oper[j - 1] = oper[j];
      }
      num_vals--;
      goto mark2;
    }
  }
  mark3:
  for (i = 0; i < num_vals - 1; i++) {
    if (oper[i] >= 37 && oper[i] <= 39 || oper[i] == 54) {
      if (oper[i] == 37)
        val = value[i] > value[i + 1];
      if (oper[i] == 38)
        val = value[i] >= value[i + 1];
      if (oper[i] == 39)
        val = value[i] <= value[i + 1];
      if (oper[i] == 54)
        val = value[i] < value[i + 1];

      value[i] = val;
      for (j = i + 1; j < num_vals - 1; j++) {
        value[j] = value[j + 1];
        oper[j - 1] = oper[j];
      }
      num_vals--;
      goto mark3;
    }
  }
  mark4:
  for (i = 0; i < num_vals - 1; i++) {
    if (oper[i] == 36 || oper[i] == 40) {
      if (oper[i] == 36)
        val = value[i] == value[i + 1];
      if (oper[i] == 40)
        val = value[i] != value[i + 1];

      value[i] = val;
      for (j = i + 1; j < num_vals - 1; j++) {
        value[j] = value[j + 1];
        oper[j - 1] = oper[j];
      }
      num_vals--;
      goto mark4;
    }
  }
  mark5:
  for (i = 0; i < num_vals - 1; i++) {
    if (oper[i] == 52) {
      val = value[i] && value[i + 1];

      value[i] = val;
      for (j = i + 1; j < num_vals - 1; j++) {
        value[j] = value[j + 1];
        oper[j - 1] = oper[j];
      }
      num_vals--;
      goto mark5;
    }
  }
  mark6:
  for (i = 0; i < num_vals - 1; i++) {
    if (oper[i] == 53) {
      val = value[i] || value[i + 1];

      value[i] = val;
      for (j = i + 1; j < num_vals - 1; j++) {
        value[j] = value[j + 1];
        oper[j - 1] = oper[j];
      }
      num_vals--;
      goto mark6;
    }
  }

  return(value[i]);
}

void start_shot(void)
{
  int x, y, dx, dy, i, count = 0;

  shot[var.total_shots].type = read_value();

  dx = read_value();
  dy = read_value();

  if (robot[rob].ammo[shot[var.total_shots].type] && var.total_shots < 1000
  && robot[rob].shot_count == 0) {
    if (shot[var.total_shots].type == SEEKS ||
    shot[var.total_shots].type == PSEEK) {
      for (i = 0; i < var.total_shots; i++)
        if (shot[i].type == SEEKS || shot[i].type == PSEEK)
          count++;
      if (!count)
        play_sample(gamedata[SEEK].dat, 255, 128, 1000, TRUE);
    }
    x = calc_x(rob) - dx;
    y = calc_y(rob) - dy;
    if (x < 0)
      x = -x;
    if (y < 0)
      y = -y;
    if (x > y) {
      if (!x) x = 1;   /* you can't divide by 0... */
      shot[var.total_shots].speed_x = 300;
      shot[var.total_shots].speed_y = (y * 300 / x);
      shot[var.total_shots].count = x / 3;
    }
    else {
      if (!y) y = 1;
      shot[var.total_shots].speed_y = 300;
      shot[var.total_shots].speed_x = (x * 300 / y);
      shot[var.total_shots].count = y / 3;
    }
    if (calc_x(rob) > dx)
      shot[var.total_shots].speed_x = -shot[var.total_shots].speed_x;
    if (calc_y(rob) > dy)
      shot[var.total_shots].speed_y = -shot[var.total_shots].speed_y;

    shot[var.total_shots].x = calc_x(rob) * 100;
    shot[var.total_shots].y = calc_y(rob) * 100;
    shot[var.total_shots].robot = rob;
    robot[rob].ammo[shot[var.total_shots].type]--;
    var.total_shots++;
    play_sample(gamedata[SHOT].dat, 255, 128, 1000, FALSE);
    robot[rob].shot_count = 30;
  }
}

ISHORT calc_x(ISHORT wrob)
{
  if (wrob != rob)
    return(robot[wrob].x);

  if (robot[wrob].x <= old_x - 1)
    return(old_x - 1);
    if (robot[wrob].x >= old_x + 1)
    return(old_x + 1);

  return(old_x);
}

ISHORT calc_y(ISHORT wrob)
{
  if (wrob != rob)
    return(robot[wrob].y);

  if (robot[wrob].y <= old_y - 1)
    return(old_y - 1);
  if (robot[wrob].y >= old_y + 1)
    return(old_y + 1);

  return(old_y);
}

void do_if(void)
{
  ISHORT val1, num_ifs = 0;

  val1 = (ISHORT)read_value();
  if (val1)
    return;

  while(code_pos <= robot[rob].code_size) {
    if (val1 == 41 /* IF */)
      num_ifs++;
    if (val1 == 42 /* ENDIF */ || val1 == 66 /* ELSE */)
      num_ifs--;
    if (num_ifs < 0)
      break;
    val1 = read_byte();
  }
}

void skip_else_code(void)
{
  ISHORT val1, num_ifs = 0;

  while(code_pos <= robot[rob].code_size) {
    val1 = read_byte();
    if (val1 == 41 /* IF */)
      num_ifs++;
    if (val1 == 42 /* ENDIF */)
      num_ifs--;
    if (num_ifs < 0)
      break;
  }
}
